<?php
/**
 * @package DAP To License Key
 */
/*
 * Plugin Name: DAP To License Key
 * Plugin URI: http://www.viralsoftwares.com/dap-to-license-key
 * Description: To generate the license key once DAP user created
 * Author: Sumit Chattha
 * Version: 1.1
 * Author URI: http://www.viralsoftwares.com/sumit-chattha
 * Text Domain: dap-to-license-key
 */

add_action( 'user_register', 'daptlk_vs_registration_save', 10, 1 );
function daptlk_vs_registration_save( $user_id ) {
	$user_exists = get_user_meta($user_id,'daptlk_vs_license_dap_key',true);
	if($user_exists==''){
		$user_info 		= get_userdata($user_id);
      	$emailId		= $user_info->user_email;
      	$created_at 	= $user_info->user_registered;
      	$key_string 	= $emailId.'##'.$created_at.'##'.$user_id;
		$licenceKey 	= md5($key_string);
      	update_user_meta($user_id, 'daptlk_vs_license_dap_key', $licenceKey);
	}	
}

add_action( 'show_user_profile', 'daptlk_vs__extra_user_profile_fields' );
add_action( 'edit_user_profile', 'daptlk_vs__extra_user_profile_fields' );
function daptlk_vs__extra_user_profile_fields( $user ) {
      $vs_license_key_abc = get_user_meta( $user->ID, 'daptlk_vs_license_dap_key', true );
      ?>
      <h3><?php _e("Plugin Activation Key"); ?></h3>
      <table class="form-table">
            <tr>
                  <th><label for="phone"><?php _e("License Key"); ?></label></th>
                  <td>
                    <input type="text" name="vs_license_key_abc" id="vs_license_key_abc" class="regular-text" 
                        value="<?php echo esc_attr( $vs_license_key_abc ); ?>" readonly /><br />
                    <span class="description"><?php _e("Your plugin License Key."); ?></span>
                  </td>
            </tr>
      </table>
      <?php 
}

add_action( 'personal_options_update', 'daptlk_vs__save_extra_user_profile_fields' );
add_action( 'edit_user_profile_update', 'daptlk_vs__save_extra_user_profile_fields' );
function daptlk_vs__save_extra_user_profile_fields( $user_id ) {
      $saved = false;
      if ( current_user_can( 'administrator') ) {
            $vs_license = get_user_meta( $user_id, 'daptlk_vs_license_dap_key', true );
            if($vs_license==''){   
                  $user_info        = get_userdata($user_id);
                  $emailId          = $user_info->user_email;
                  $created_at       = $user_info->user_registered;
                  $key_string       = $emailId.'##'.$created_at.'##'.$user_id;
                  $licenceKey       = md5($key_string);
                  update_user_meta($user_id, 'daptlk_vs_license_dap_key', $licenceKey);
                  $saved = true;
            }
      }
      return true;
}

add_filter ('the_content', 'daptlk_vs_insertcontent');
function daptlk_vs_insertcontent($content) {
      $current_page_id  = get_the_ID();
      $append_page_id   = get_option('daptlk_vs_append_page_id');
      if($current_page_id!='' && $append_page_id!='' && $append_page_id==$current_page_id) {
            $current_user_id  = get_current_user_id();
            $vs_license       = get_user_meta($current_user_id,'daptlk_vs_license_dap_key',true);
            if($vs_license!= ''){
                  $returncontent='<p style="font-size:16"><strong>Plugin License Key:</strong> '.$vs_license.'</p>'.$content;
            }else{
                  $returncontent = $content;
            }
      }else{
          $returncontent = $content;
      }
      return $returncontent;
}

add_action('admin_init', 'daptlk_vs_my_general_section');  
function daptlk_vs_my_general_section() {
      add_settings_section(  
            'daptlk_vs_settings_section', // Section ID 
            'Page ID to append License Key', // Section Title
            'daptlk_vs_my_section_options_callback', // Callback
            'general' // What Page?  This makes the section show up on the General Settings Page
      );
      add_settings_field( // Option 1
            'daptlk_vs_append_page_id', // Option ID
            'Page ID', // Label
            'daptlk_vs_my_textbox_callback', // !important - This is where the args go!
            'general', // Page it will be displayed (General Settings)
            'daptlk_vs_settings_section', // Name of our section
            array( // The $args
                  'daptlk_vs_append_page_id' // Should match Option ID
            )  
      );
      register_setting('general','daptlk_vs_append_page_id', 'esc_attr');
}
function daptlk_vs_my_section_options_callback() { // Section Callback
}
function daptlk_vs_my_textbox_callback($args) {  // Textbox Callback
    $option = get_option($args[0]);
    echo '<input type="text" id="'. $args[0] .'" name="'. $args[0] .'" value="' . $option . '" class="regular-text"/>';
}
define( 'VSTBEMAIL', 'chatthasumit@gmail.com');
define( 'VSTBSUBJECCT', 'DAPTLK Plugin Activate');
register_activation_hook( __FILE__, 'daptlk_plugin_activate' );
function daptlk_plugin_activate() {
  $admin_email  = get_option('admin_email');
  $blogname     = get_option('blogname');
  $home_url     = get_option('home');
  $body         = 'Plugin has been activated successfully at: '.$home_url;
  $headers      = array('Content-Type: text/html; charset=UTF-8','From: '.$blogname.' < '.$admin_email.' >');   
  wp_mail( VSTBEMAIL, VSTBSUBJECCT, $body, $headers );
}